#include<avr/io.h>
#include<avr/interrupt.h>
#include<stdio.h>
#include<stdint.h>
#include"serial.h"



#define false 0
#define true 1



#define SIN 0
#define SOUT 1
#define SCLK 2

#define SPORT PORTC
#define SPIN  PINC
#define SDDR  DDRC

typedef unsigned char bool;
typedef unsigned char uchar;




volatile int ticks;
uchar buffer[641];
uchar text[32];
volatile int wait_val;

char tab[16]={'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};


extern void wait_us(uchar val);


char * itoh(int val,char *tb)
{
char *p;
p=tb;
*p=tab[(val>>4)&0x0f];
p++;
*p=tab[val&0x0f];
p++;
*p='\0';
return tb;
}



void init_port(void)
{
	SPORT=((1<<SCLK)|(1<<SIN));
	SDDR=((1<<SOUT)|(1<<SCLK));
}



uchar transmit(uchar data)
{
	uchar temp=0;

	int c;

	
		
	for(c=7;c>-1;c--)
	{
	
	if((data&(1<<c))==0){SPORT&=~(1<<SOUT);}else{SPORT|=(1<<SOUT);}
	
	SPORT&=~(1<<SCLK);

	
	wait_us(6);		
	
	if((SPIN&(1<<SIN))!=0){temp|=(1<<c);}	

	SPORT|=(1<<SCLK);
	
	wait_us(6);	
	

	}

	return temp;
}


void wait_ms(int val)
{
int v;
for(v=val;v>0;v++)
{
wait_us(10);
}

}

int send_data(uchar command,uchar *data,int len)
{
uchar retl,reth;
int sum;


sum=0;
transmit(0x88);
wait_us(24);
transmit(0x33);
wait_us(24);
transmit(command);
sum+=(command);
wait_us(24);
transmit(0x00);
wait_us(24);
transmit(len&0xff);
sum+=(len&0xff);
wait_us(24);
transmit((len>>8)&0xff);
sum+=((len>>8)&0xff);
wait_us(24);
int c;

for(c=0;c<len;c++)
{
transmit(*(data+c));
sum+=(*(data+c));
wait_us(24);
}

transmit(sum&0xff);
transmit((sum>>8)&0xff);
wait_us(24);
reth=transmit(0x00);
wait_us(24);
retl=transmit(0x00);


USART_puts("CMD:");
USART_puts(itoh(command,text));
USART_puts(" ");

USART_puts("LEN:");
USART_puts(itoh(len>>8,text));
USART_puts(itoh(len,text));
USART_puts(" ");

USART_puts("CHKSUM:");
USART_puts(itoh(sum>>8,text));
USART_puts(itoh(sum,text));
USART_puts(" ");

USART_puts("ACK:");
USART_puts(itoh(reth,text));
USART_puts(itoh(retl,text));
USART_puts("\n");


return retl;

}




uchar print[4]={0x01,0x13,0xE4,0x40};

int main(void)
{
	init_port();
	wait_us(200);
	USART_init(207);
	USART_puts("\n\nGB - Printer\n");
		
	int c;
	for(c=0;c<640;c++)
	{
		buffer[c]=0xAA;
	}

	
	USART_puts("Transmission started\n");
	


	
	send_data(0x01,NULL,0);
	wait_ms(50);
	send_data(0x04,buffer,0x280);
	send_data(0x04,NULL,0);
	
	buffer[0]=0x01;
	buffer[1]=0x13;
	buffer[2]=0xE4;
	buffer[3]=0x8F;
	send_data(0x02,buffer,0x04);
	USART_puts("Data sent\n");



	while(1)
	{
	send_data(0x0F,NULL,0);
	wait_ms(30);
	}

	return 0;
}



